org.springframework.http.codec

## Interface ClientCodecConfigurer

- All Superinterfaces:
    CodecConfigurer
  All Known Implementing Classes:
    DefaultClientCodecConfigurer

      public interface ClientCodecConfigurer
      extends CodecConfigurer

  Extension of `CodecConfigurer` for HTTP message reader and writer options relevant on the client side.

  HTTP message readers for the following are registered by default:

  `byte[]`
  - `ByteBuffer`
  - `DataBuffer`
  - `Resource`
  - `String`
  - `MultiValueMap<String,String>` for form data
  - JSON and Smile, if Jackson is present
  - XML, if JAXB2 is present
  - Server-Sent Events

  HTTP message writers registered by default:

  `byte[]`
  - `ByteBuffer`
  - `DataBuffer`
  - `Resource`
  - `String`
  - `MultiValueMap<String,String>` for form data
  - `MultiValueMap<String,Object>` for multipart data
  - JSON and Smile, if Jackson is present
  - XML, if JAXB2 is present
  Since:
    5.0
  Author:
    Rossen Stoyanchev

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `ClientCodecConfigurer.ClientDefaultCodecs` `CodecConfigurer.DefaultCodecs` extension with extra client-side options.
    `static interface` | `ClientCodecConfigurer.MultipartCodecs` Registry and container for multipart HTTP message writers.

    - ### Nested classes/interfaces inherited from interface org.springframework.http.codec.CodecConfigurer

      `CodecConfigurer.CustomCodecs, CodecConfigurer.DefaultCodecConfig, CodecConfigurer.DefaultCodecs`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClientCodecConfigurer` | `clone()` Create a copy of this `CodecConfigurer`.
    `static ClientCodecConfigurer` | `create()` Static factory method for a `ClientCodecConfigurer`.
    `ClientCodecConfigurer.ClientDefaultCodecs` | `defaultCodecs()` Provides a way to customize or replace HTTP message readers and writers registered by default.

    - ### Methods inherited from interface org.springframework.http.codec.CodecConfigurer

      `customCodecs, getReaders, getWriters, registerDefaults`

- - ### Method Detail

    - #### defaultCodecs

          ClientCodecConfigurer.ClientDefaultCodecs defaultCodecs()

      Provides a way to customize or replace HTTP message readers and writers registered by default.

      On the client side, built-in default also include customizations related to multipart readers and writers, as well as the decoder for SSE.

      Specified by:
        `defaultCodecs` in interface `CodecConfigurer`
      See Also:
        `CodecConfigurer.registerDefaults(boolean)`

    - #### clone

          ClientCodecConfigurer clone()

      Create a copy of this `CodecConfigurer`. The returned clone has its own lists of default and custom codecs and generally can be configured independently. Keep in mind however that codec instances (if any are configured) are themselves not cloned..
      Specified by:
        `clone` in interface `CodecConfigurer`

    - #### create

          static ClientCodecConfigurer create()

      Static factory method for a `ClientCodecConfigurer`.